=== docs/mfront/CMakeLists.txt ===
macro(install_mfront_desc file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${file}.md DESTINATION share/doc/mfront
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc file)

macro(install_mfront_desc2 directory file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${directory}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${directory}/${file}.md
      DESTINATION share/doc/mfront/${directory}
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc2 directory file)

macro(install_mfront_desc3 directory1 directory2 file)
  if(TFEL_APPEND_SUFFIX)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory1}
      COMPONENT mfront)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront-${TFEL_SUFFIX}/${directory2}
      COMPONENT mfront)
  else(TFEL_APPEND_SUFFIX)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront/${directory1}
      COMPONENT mfront)
    install(FILES ${directory1}/${file}.md
      DESTINATION share/doc/mfront/${directory2}
      COMPONENT mfront)
  endif(TFEL_APPEND_SUFFIX)
endmacro(install_mfront_desc3 directory file)

install_mfront_desc(AdditionalConvergenceChecks)
install_mfront_desc(AdditionalTangentOperatorBlock)
install_mfront_desc(AdditionalTangentOperatorBlocks)
install_mfront_desc(Algorithm)
install_mfront_desc(Author)
install_mfront_desc(AuxiliaryModel)
install_mfront_desc(AuxiliaryStateVar)
install_mfront_desc(AuxiliaryStateVariable)
install_mfront_desc(AxialGrowth)
install_mfront_desc(Behaviour)
install_mfront_desc(BehaviourVariable)
install_mfront_desc(BehaviourVariableFactory)
install_mfront_desc(Bounds)
install_mfront_desc(Brick)
install_mfront_desc(Coef)
install_mfront_desc(ComputeFinalStress)
install_mfront_desc(ComputeStiffnessTensor)
install_mfront_desc(ComputeStressFreeExpansion)
install_mfront_desc(ComputeStress)
install_mfront_desc(ComputeThermalExpansion)
install_mfront_desc(CompareToNumericalJacobian)
install_mfront_desc(CrystalStructure)
install_mfront_desc(Date)
install_mfront_desc(Description)
install_mfront_desc(DislocationsMeanFreePathInteractionMatrix)
install_mfront_desc(DissipatedEnergy)
install_mfront_desc(DSL)
install_mfront_desc(ElasticMaterialProperties)
install_mfront_desc(Epsilon)
install_mfront_desc(ExternalStateVar)
install_mfront_desc(ExternalStateVariable)
install_mfront_desc(GlidingSystem)
install_mfront_desc(GlidingSystems)
install_mfront_desc(Import)
install_mfront_desc(InitializeJacobian)
install_mfront_desc(InitializeJacobianInvert)
install_mfront_desc(InitJacobian)
install_mfront_desc(InitJacobianInvert)
install_mfront_desc(Includes)
install_mfront_desc(InteractionMatrix)
install_mfront_desc(IntegrationVariable)
install_mfront_desc(Interface)
install_mfront_desc(InternalEnergy)
install_mfront_desc(InitLocalVars)
install_mfront_desc(InitLocalVariables)
install_mfront_desc(InitializeLocalVariables)
install_mfront_desc(InitializeFunction)
install_mfront_desc(InitializeFunctionVariable)
install_mfront_desc(IsotropicBehaviour)
install_mfront_desc(IsotropicElasticBehaviour)
install_mfront_desc(IsotropicHardeningRule)
install_mfront_desc(IsotropicHardeningRules)
install_mfront_desc(IterMax)
install_mfront_desc(JacobianComparisonCriterion)
install_mfront_desc(JacobianComparisonCriterium)
install_mfront_desc(Library)
install_mfront_desc(Link)
install_mfront_desc(LocalVar)
install_mfront_desc(Material)
install_mfront_desc(MaterialLaw)
install_mfront_desc(MaterialProperty)
install_mfront_desc(MaximumNumberOfIterations)
install_mfront_desc(MaximalTimeStepScalingFactor)
install_mfront_desc(MinimalTimeStepScalingFactor)
install_mfront_desc(Model)
install_mfront_desc(NumericallyComputedJacobianBlocks)
install_mfront_desc(OrthotropicBehaviour)
install_mfront_desc(Parameter)
install_mfront_desc(Parser)
install_mfront_desc(PerturbationValueForNumericalJacobianComputation)
install_mfront_desc(PhysicalBounds)
install_mfront_desc(PostProcessing)
install_mfront_desc(PostProcessingVariable)
install_mfront_desc(ProcessNewCorrection)
install_mfront_desc(ProcessNewEstimate)
install_mfront_desc(Private)
install_mfront_desc(Profiling)
install_mfront_desc(Relocation)
install_mfront_desc(RejectCurrentCorrection)
install_mfront_desc(RequireStiffnessOperator)
install_mfront_desc(RequireStiffnessTensor)
install_mfront_desc(RequireThermalExpansionCoefficientTensor)
install_mfront_desc(SlidingSystem)
install_mfront_desc(SlidingSystems)
install_mfront_desc(SlipSystem)
install_mfront_desc(SlipSystems)
install_mfront_desc(Sources)
install_mfront_desc(SpeedOfSound)
install_mfront_desc(StateVar)
install_mfront_desc(StateVariable)
install_mfront_desc(StaticVar)
install_mfront_desc(StaticVariable)
install_mfront_desc(StrainMeasure)
install_mfront_desc(Swelling)
install_mfront_desc(TangentOperator)
install_mfront_desc(TangentOperatorBlock)
install_mfront_desc(TangentOperatorBlocks)
install_mfront_desc(Theta)
install_mfront_desc(UnitSystem)
install_mfront_desc(UpdateAuxiliaryStateVars)
install_mfront_desc(UpdateAuxiliaryStateVariables)
install_mfront_desc(UsableInPurelyImplicitResolution)
install_mfront_desc(UseQt)

install_mfront_desc2(Implicit HillTensor)

install_mfront_desc3(MaterialLaw MaterialProperty Constant)
install_mfront_desc3(MaterialLaw MaterialProperty Data)
install_mfront_desc3(MaterialLaw MaterialProperty Function)
install_mfront_desc3(MaterialLaw MaterialProperty Input)
install_mfront_desc3(MaterialLaw MaterialProperty Law)
install_mfront_desc3(MaterialLaw MaterialProperty MFront)
install_mfront_desc3(MaterialLaw MaterialProperty Output)

install_mfront_desc2(Model ConstantMaterialProperty)
install_mfront_desc2(Model Domain)
install_mfront_desc2(Model Domains)
install_mfront_desc2(Model Function)
install_mfront_desc2(Model Input)
install_mfront_desc2(Model Integrator)
install_mfront_desc2(Model GlobalParameter)
install_mfront_desc2(Model LocalParameter)
install_mfront_desc2(Model Model)
install_mfront_desc2(Model Output)
install_mfront_desc2(Default Integrator)
install_mfront_desc2(ImplicitGenericBehaviour Integrator)
install_mfront_desc2(DefaultCZM Integrator)
install_mfront_desc2(DefaultGenericBehaviour Integrator)
install_mfront_desc2(Implicit Integrator)
install_mfront_desc2(ImplicitFiniteStrain Integrator)
install_mfront_desc2(ImplicitII Integrator)
install_mfront_desc2(Model Integrator)
install_mfront_desc2(ImplicitCZM Integrator)
install_mfront_desc2(DefaultFiniteStrain Integrator)

install_mfront_desc2(bricks StandardElasticity)
install_mfront_desc2(bricks DDIF2)

install_mfront_desc2(stress-potentials Hooke)
install_mfront_desc2(stress-potentials DDIF2)

if(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

  configure_file(glossary.tex.in
    glossary.tex @ONLY)
  add_subdirectory(general)
  add_subdirectory(behaviours)
  add_subdirectory(finitestrain)
  add_subdirectory(planestress)
  add_subdirectory(castem)
  add_subdirectory(aster)
  add_subdirectory(zmat)

endif(HAVE_LATEX AND GENERATE_REFERENCE_DOC)

add_subdirectory(abaqus)
add_subdirectory(dianafea)
add_subdirectory(ansys)
add_subdirectory(lsdyna)
